/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the MarkTaskAsClosedRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MarkTaskAsClosedRequest{}

// MarkTaskAsClosedRequest struct for MarkTaskAsClosedRequest
type MarkTaskAsClosedRequest struct {
	// If completed tasks refers to media assed, here we should get media file key
	MediaFileKey *string `json:"media_file_key,omitempty"`
}

// NewMarkTaskAsClosedRequest instantiates a new MarkTaskAsClosedRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMarkTaskAsClosedRequest() *MarkTaskAsClosedRequest {
	this := MarkTaskAsClosedRequest{}
	return &this
}

// NewMarkTaskAsClosedRequestWithDefaults instantiates a new MarkTaskAsClosedRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMarkTaskAsClosedRequestWithDefaults() *MarkTaskAsClosedRequest {
	this := MarkTaskAsClosedRequest{}
	return &this
}

// GetMediaFileKey returns the MediaFileKey field value if set, zero value otherwise.
func (o *MarkTaskAsClosedRequest) GetMediaFileKey() string {
	if o == nil || IsNil(o.MediaFileKey) {
		var ret string
		return ret
	}
	return *o.MediaFileKey
}

// GetMediaFileKeyOk returns a tuple with the MediaFileKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MarkTaskAsClosedRequest) GetMediaFileKeyOk() (*string, bool) {
	if o == nil || IsNil(o.MediaFileKey) {
		return nil, false
	}
	return o.MediaFileKey, true
}

// HasMediaFileKey returns a boolean if a field has been set.
func (o *MarkTaskAsClosedRequest) HasMediaFileKey() bool {
	if o != nil && !IsNil(o.MediaFileKey) {
		return true
	}

	return false
}

// SetMediaFileKey gets a reference to the given string and assigns it to the MediaFileKey field.
func (o *MarkTaskAsClosedRequest) SetMediaFileKey(v string) {
	o.MediaFileKey = &v
}

func (o MarkTaskAsClosedRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MarkTaskAsClosedRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.MediaFileKey) {
		toSerialize["media_file_key"] = o.MediaFileKey
	}
	return toSerialize, nil
}

type NullableMarkTaskAsClosedRequest struct {
	value *MarkTaskAsClosedRequest
	isSet bool
}

func (v NullableMarkTaskAsClosedRequest) Get() *MarkTaskAsClosedRequest {
	return v.value
}

func (v *NullableMarkTaskAsClosedRequest) Set(val *MarkTaskAsClosedRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableMarkTaskAsClosedRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableMarkTaskAsClosedRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMarkTaskAsClosedRequest(val *MarkTaskAsClosedRequest) *NullableMarkTaskAsClosedRequest {
	return &NullableMarkTaskAsClosedRequest{value: val, isSet: true}
}

func (v NullableMarkTaskAsClosedRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMarkTaskAsClosedRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


